#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <math.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"
#include "rotation.h"
#include "led.h"


int ioperm(unsigned long from, unsigned long num, int turn_on);

int main(){
	
	int target_post;
	int ret;
	int i;
	double angle;
	int direction;
	int post_sure=0;

	FILE *fmain,*fpid,*fpia,*fsrd,*fsra,*fstd,*fsta,*fpn;

	fmain=fopen("main_line.txt","w");

	target_post=1;

	ioperm(PORT,1,1);

	printf("Initialize! \n");
	ret=initialize();
	fprintf(fmain,"Main Program Start!\n");
	fprintf(fmain,"\nmove function <initialize> \n");	
	fprintf(fmain,"Initialize! \n");
	fprintf(fmain,"Initialize:search_try_count=%d\n",search_try_count);


	/********** get post infomation **********/
	
	fprintf(fmain,"\nmove function <rot2> \n");
	angle=180.0;
	direction=1;
	printf("RB_Search 1st Try! ");
	printf(": angle=%f,direction=%d\n",angle,direction);

	pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
	usleep(300000);
	rot2(angle,direction);
	pthread_cancel(uss_task2);
	usleep(300000);
	search_try_count++;

	fprintf(fmain,"RB_Search 1st Try! ");
	fprintf(fmain,": angle=%f,direction=%d \n",angle,direction);
	printf("angle_now=%f\n",angle_now);
	fprintf(fmain,"RB:angle_now=%f\n",angle_now);
	fprintf(fmain,"RB2:search_try_count=%d\n",search_try_count);


	/********** RB move back_position **********/

	printf("RB Rotate 90[deg]! \n");

	angle=270;
	usleep(300000);
	rot1(angle,direction);
	usleep(300000);

	printf("angle_now=%f\n",angle_now);
	fprintf(fmain,"\nmove function <rot1> \n");
	fprintf(fmain,"RB Rotate 90[deg]! Move back_Position. \n");
	fprintf(fmain,"RB:angle_now=%f \n",angle_now);
	fprintf(fmain,"RB:search_try_count=%d\n",search_try_count);


LOOP:	/********** Loop Point **********/

	if(post.got_number==POST_NUM){
		goto END;
	}


	/********** dis_info[] -> dis_select[] , ang_info[] -> ang_select[] **********/

	printf("Select Post Infomation! \n");
	fprintf(fmain,"\nSelect Post Infomation! \n");

	usleep(10000);
	if(search_try_count==1 || warning_point==3){
		fprintf(fmain,"move function <select_post> \n");
		fprintf(fmain,"SEL:search_try_count=%d\n",search_try_count);
		select_post();
	}else{
		fprintf(fmain,"move function <select_post2> \n");
		fprintf(fmain,"SEL2:search_try_count=%d\n",search_try_count);
		select_post2();
	}
	usleep(10000);

	printf("Searched Post = %d ! \n",search_post);
	fprintf(fmain,"Searched Post = %d ! \n\n",search_post);
	if(search_post==0){
		if(warning_point!=3){
			warning_point=1;
			printf("warning_point! Case:%d \nThere is NO Search Post!\n",warning_point);
			fprintf(fmain,"warning_point! Case:%d \n--There is NO Search Post!\n",warning_point);
			fprintf(fmain,"ROUTE5,case1:search_try_count=%d\n",search_try_count);
		
			outb(FLASH5,PORT);
			sleep(5);
			outb(STOP,PORT);

			usleep(10000);
			route5();
			usleep(10000);

			angle=270;
			usleep(300000);
			rot1(angle,direction);
			usleep(300000);

			ang_before=ang_now;
			dis_before=dis_now;
			search_try_count++;
			fprintf(fmain,"warning_point! Case:%d \n--Move Center Flag!\n",warning_point);
			fprintf(fmain,"ROUTE5,case1,after:search_try_count=%d\n",search_try_count);
			goto LOOP;
		}else{
			printf("CENTER Search:There is NO Post!\n");
			fprintf(fmain,"CENTER Search:There is NO Post!\n");
			fprintf(fmain,"BAD END!\n");
			goto END;
		}
	}

	for(i=0;i<search_post;i++){
		printf("ang_select[%d]=%d , dis_select[%d]=%d \n",i,ang_select[i],i,dis_select[i]);
		fprintf(fmain,"ang_select[%d]=%d , dis_select[%d]=%d \n",i,ang_select[i],i,dis_select[i]);
	}

	/********** dis_select[] -> dis_approach , ang_select[] -> ang_approach **********/

	fprintf(fmain,"\nmove function <route4> \n");
	printf("search_try_count=%d\n",search_try_count);
	printf("Calculated Route! \n");
	fprintf(fmain,"ROUTE4,cose1:search_try_count=%d\n",search_try_count);
	fprintf(fmain,"Calculated Route! \n");

	usleep(10000);
	route4();
	usleep(10000);

	printf("ang_approach=%d , dis_approach=%d \n",ang_approach,dis_approach);
	printf("ang_now_1st=%d\n",ang_now_1st);
	printf("before:\n ang=%d , dis=%d\n",ang_before,dis_before);
	printf("now:\n ang=%d , dis=%d\n",ang_now,dis_now);
	printf("post_dis_dumy={%f,%f,%f,%f,%f}\n",post_dis_dumy[0],post_dis_dumy[1],post_dis_dumy[2],post_dis_dumy[3],post_dis_dumy[4]);
	printf("post_ang_dumy={%f,%f,%f,%f,%f}\n",post_ang_dumy[0],post_ang_dumy[1],post_ang_dumy[2],post_ang_dumy[3],post_ang_dumy[4]);
	fprintf(fmain,"ang_approach=%d , dis_approach=%d \n",ang_approach,dis_approach);
	fprintf(fmain,"ang_now_1st=%d\n",ang_now_1st);
	fprintf(fmain,"before:\n ang=%d , dis=%d\n",ang_before,dis_before);
	fprintf(fmain,"now:\n ang=%d , dis=%d\n",ang_now,dis_now);
	fprintf(fmain,"post_dis_dumy={%f,%f,%f,%f,%f}\n",post_dis_dumy[0],post_dis_dumy[1],post_dis_dumy[2],post_dis_dumy[3],post_dis_dumy[4]);
	fprintf(fmain,"post_ang_dumy={%f,%f,%f,%f,%f}\n",post_ang_dumy[0],post_ang_dumy[1],post_ang_dumy[2],post_ang_dumy[3],post_ang_dumy[4]);


	/********** approach post **********/

	fprintf(fmain,"\nmove function <post_approach0702> \n");
	printf("Approach Post! \n");
	fprintf(fmain,"Approach Post! \n");
	fprintf(fmain,"APPROACH:search_try_count=%d\n",search_try_count);

	pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
	usleep(300000);	
	post_sure=post_approach0702(target_post);
	usleep(300000);
	pwm_both_data(0,0);
	usleep(400000);
	pthread_cancel(uss_task2);
	usleep(300000);

	if(post_sure==0){
		fprintf(fmain,"Post_approach Successed! \n");
	}else{
		warning_point=2;
		printf("warning_point! Case:%d \nThere is NO Approach Post!\n",warning_point);
		fprintf(fmain,"warning_point! Case:%d \n--There is NO Approach Post!\n",warning_point);
		fprintf(fmain,"ROUTE5,case2:search_try_count=%d\n",search_try_count);

		outb(FLASH6,PORT);
		sleep(5);
		outb(STOP,PORT);

		usleep(10000);
		route5();
		usleep(10000);

		fprintf(fmain,"warning_point! Case:%d \n--There is NO Approach Post!\n",warning_point);
		fprintf(fmain,"ROUTE5,case2,after:search_try_count=%d\n",search_try_count);
		if(warning_point==1){
			printf("warning_point! Case:%d \nThere is NO Search Post!\n",warning_point);
			fprintf(fmain,"warning_point! Case:%d \n--There is NO Search Post!\n",warning_point);
			fprintf(fmain,"ROUTE5,case1:search_try_count=%d\n",search_try_count);

			outb(FLASH5,PORT);
			sleep(5);
			outb(STOP,PORT);

			usleep(10000);
			route5();
			usleep(10000);

			angle=270;
			usleep(300000);
			rot1(angle,direction);
			usleep(300000);
			search_try_count++;
			fprintf(fmain,"warning_point! Case:%d \n--Move Center Flag!\n",warning_point);
			fprintf(fmain,"ROUTE5,case1,after:search_try_count=%d\n",search_try_count);
			goto LOOP;
		}
		dis_now=dis_approach;
		ang_now=ang_approach;
	}


	/********** confirm MIRS_position **********/

	fprintf(fmain,"\nmove function <bypass> \n");
	fprintf(fmain,"BYPASS:search_try_count=%d\n",search_try_count);
	usleep(10000);
	bypass();
	usleep(10000);
	if(post_sure==0){
		post_dis[sure]=post_dis_dumy[search_try_count-1];
		post_ang[sure]=post_ang_dumy[search_try_count-1];

		sure++;
		search_try_sure++;
		post.got_number++;

		fprintf(fmain,"post_dis={%f,%f,%f,%f,%f}\n",post_dis[0],post_dis[1],post_dis[2],post_dis[3],post_dis[4]);
		fprintf(fmain,"post_ang={%f,%f,%f,%f,%f}\n",post_ang[0],post_ang[1],post_ang[2],post_ang[3],post_ang[4]);
		fprintf(fmain,"sure=%d\n",sure);
		fprintf(fmain,"search_try_sure=%d\n",search_try_sure);
	}
	flag_calculated=0;
	printf("before<bypass>:\n ang=%d , dis=%d\n",ang_before,dis_before);
	printf("now<bypass>:\n ang=%d , dis=%d\n",ang_now,dis_now);
	fprintf(fmain,"before:\n ang=%d , dis=%d\n",ang_before,dis_before);
	fprintf(fmain,"now:\n ang=%d , dis=%d\n",ang_now,dis_now);


	/********** caluculate distance bitween post to start point **********/

	fprintf(fmain,"\nmove function <route1> \n");
	printf("Calculated Short Distance! \n");
	fprintf(fmain,"Calculated Short Distance! \n");
	fprintf(fmain,"ROUTE1:search_try_count=%d\n",search_try_count);

	usleep(10000);
	route1();
	usleep(10000);

	printf("short_dis={%f,%f,%f,%f,%f}\n",short_dis[0],short_dis[1],short_dis[2],short_dis[3],short_dis[4]);
	printf("short_ang={%f,%f,%f,%f,%f}\n",short_ang[0],short_ang[1],short_ang[2],short_ang[3],short_ang[4]);
	fprintf(fmain,"short_dis={%f,%f,%f,%f,%f}\n",short_dis[0],short_dis[1],short_dis[2],short_dis[3],short_dis[4]);
	fprintf(fmain,"short_ang={%f,%f,%f,%f,%f}\n",short_ang[0],short_ang[1],short_ang[2],short_ang[3],short_ang[4]);


	/********** get post **********/

	fprintf(fmain,"\nmove function <post_get0702_2> \n");
	printf("Get_Post Action! \n");
	fprintf(fmain,"Get_Post Action! \n");
	fprintf(fmain,"GET_3,before:search_try_count=%d\n",search_try_count);

	pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
	usleep(300000);	
	target_post=post_get0702_3(target_post);
	pthread_cancel(uss_task2);
	usleep(300000);
	search_try_count++;

	fprintf(fmain,"post_number_code={%d,%d,%d,%d,%d}\n",post_number_code[0],post_number_code[1],post_number_code[2],post_number_code[3],post_number_code[4]);
	fprintf(fmain,"GET_3,after:search_try_count=%d\n",search_try_count);
	fpn=fopen("post_num_code.txt","a");
	fprintf(fpn,"%d\n",post_number_code[sure-1]);
	fclose(fpn);


	/********** Return to LOOP **********/
	
	goto LOOP;

	
END:	/********** END action **********/

	outb(FLASH7,PORT);
	usleep(1000);

	/********** caluculate shortert route **********/

	fprintf(fmain,"move function <route2> \n");
	printf("Calculated Shortest Route! \n");
	fprintf(fmain,"Calculated Shortest Route! \n");

	usleep(10000);
	route2();
	usleep(10000);

	usleep(300000);
	pwm_both_data(0,0);
	usleep(400000);
	pwm_enco_stop();
	usleep(400000);

	printf("shortest_dis={%f,%f,%f,%f,%f}\n",m_s_dis[0],m_s_dis[1],m_s_dis[2],m_s_dis[3],m_s_dis[4]);
	printf("shortest_ang={%f,%f,%f,%f,%f}\n",m_s_ang[0],m_s_ang[1],m_s_ang[2],m_s_ang[3],m_s_ang[4]);
	fprintf(fmain,"shortest_dis={%f,%f,%f,%f,%f}\n",m_s_dis[0],m_s_dis[1],m_s_dis[2],m_s_dis[3],m_s_dis[4]);
	fprintf(fmain,"shortest_ang={%f,%f,%f,%f,%f}\n",m_s_ang[0],m_s_ang[1],m_s_ang[2],m_s_ang[3],m_s_ang[4]);

	printf("Main Program END! \n");
	fprintf(fmain,"Main Program END! \n");
	fclose(fmain);

	fpid=fopen("post_info_dis.txt","w");
	fpia=fopen("post_info_ang.txt","w");
	fsrd=fopen("post_info_dis.txt","w");
	fsra=fopen("post_info_ang.txt","w");
	fstd=fopen("shortest_dis.txt","w");
	fsta=fopen("shortest_ang.txt","w");
	for(i=0;i<POST_NUM+1;i++){
		fprintf(fpid,"%f\n",post_dis[i]);
		fprintf(fpia,"%f\n",post_ang[i]);
		fprintf(fsrd,"%f\n",short_dis[i]);
		fprintf(fsra,"%f\n",short_ang[i]);
		fprintf(fstd,"%f \n",m_s_dis[i]);
		fprintf(fsta,"%f \n",m_s_ang[i]);
	}
	fclose(fpid);
	fclose(fpia);
	fclose(fsrd);
	fclose(fsra);
	fclose(fsta);
	fclose(fstd);

	sleep(10);
	outb(STOP,PORT);
	usleep(1000);

	return 0;
}
	
