#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <math.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"
#include "rotation.h"
#include "led.h"


int bypass(){
	double dis_b,ang_b,ang_b_d;

	if(warning_point!=3 && search_try_count>1){
		ang_before=ang_now;
		dis_before=dis_now;
		warning_point=0;
	}else{
		if(ang_before>180){
			ang_before=360-ang_before;
		}
		switch(flag_calculated){
			/***** START POINT *****/
			case 1:
				dis_before=FIELD_DIAMETER/2;
				ang_before=90+ang_now;
				if(ang_before > 180){
					ang_b_d=360-ang_before;
				}
				if(ang_before < 180){
					ang_b_d=ang_before;
				}
				if(ang_before == 180){
					ang_b_d=ang_before;
				}
				dis_b=sqrt(pow(dis_before,2)+pow(dis_now,2)-2*dis_now*dis_before*cos(ang_b_d*3.1415927/180));
				ang_b=asin(dis_now*sin((ang_now+90)*3.1415927/180)/dis_b)*180/3.1415927;
				ang_cent=180-ang_before-ang_b;
				
				if(ang_before > 180){
					ang_b=90+ang_b;
					ang_cent=(-1)*ang_cent;
				}
				if(ang_before < 180){
					ang_b=90-ang_b;
					ang_cent=ang_cent;
				}
				if(ang_before == 180){
					ang_b=90;
					ang_cent=0;
				}
		
				post_ang_dumy[search_try_count-1]=ang_b;
				post_dis_dumy[search_try_count-1]=dis_b;
				ang_before=ang_b;
				dis_before=dis_b;

				warning_point=4;
				break;
	
			/***** 1st quadrant *****/
			case 2:
				if((ang_now+ang_cent_a) > 180){
					ang_b_d=360-(ang_now+ang_cent_a);
				}
				if((ang_now+ang_cent_a) < 180){
					ang_b_d=ang_now+ang_cent_a;
				}
				if((ang_now+ang_cent_a) == 180){
					ang_b_d=ang_now+ang_cent_a;
				}
				dis_b=sqrt(pow(dis_before,2)+pow(dis_now,2)-2*dis_now*dis_before*cos(ang_b_d*3.1415927/180));
				ang_b=asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;
	
				ang_cent=180-ang_b_d-asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;

				if((ang_now+ang_cent_a) > 180){
					ang_b=360-ang_before+ang_b;
					ang_cent=(-1)*ang_cent;
				}
				if((ang_now+ang_cent_a) < 180){
					ang_b=360-ang_before-ang_b;
					ang_cent=ang_cent;
				}
				if((ang_now+ang_cent_a) == 180){
					ang_b=180;
					ang_cent=0;
				}

				post_ang_dumy[search_try_count-1]=ang_b;
				post_dis_dumy[search_try_count-1]=dis_b;
				ang_before=ang_b;
				dis_before=dis_b;
		
				warning_point=4;
				break;

			case 3:
				if((90-ang_cent_a+ang_now) > 180){
					ang_b_d=360-(90-ang_cent_a+ang_now);
				}
				if((90-ang_cent_a+ang_now) < 180){
					ang_b_d=90-ang_cent_a+ang_now;
				}
				if((90-ang_cent_a+ang_now) == 180){
					ang_b_d=90-ang_cent_a+ang_now;
				}
				dis_b=sqrt(pow(dis_before,2)+pow(dis_now,2)-2*dis_now*dis_before*cos(ang_b_d*3.1415927/180));
				ang_b=asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;

				ang_cent=180-ang_b_d-asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;

				if((90-ang_cent_a+ang_now) > 180){
					ang_b=ang_before-ang_b;
					ang_cent=ang_cent;
				}
				if((90-ang_cent_a+ang_now) < 180){
					ang_b=ang_before+ang_b;
					ang_cent=(-1)*ang_cent;
				}
				if((90-ang_cent_a+ang_now) == 180){
					ang_b=180;
					ang_cent=0;
				}
			
				post_ang_dumy[search_try_count-1]=ang_b;
				post_dis_dumy[search_try_count-1]=dis_b;
				ang_before=ang_b;
				dis_before=dis_b;

				warning_point=4;
				break;

			/***** 2nd quadrant *****/
			case 4:
				if((ang_cent_a+ang_now) > 180){
					ang_b_d=360-(ang_cent_a+ang_now);
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				dis_b=sqrt(pow(dis_before,2)+pow(dis_now,2)-2*dis_now*dis_before*cos(ang_b_d*3.1415927/180));
				ang_b=asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;
	
				ang_cent=180-ang_b_d-asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;
	
				if((ang_cent_a+ang_now) > 180){
					ang_b=ang_before+ang_b;
					ang_cent=ang_cent;
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b=ang_before-ang_b;
					ang_cent=(-1)*ang_cent;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b=180;
					ang_cent=0;
				}
				
				post_ang_dumy[search_try_count-1]=ang_b;
				post_dis_dumy[search_try_count-1]=dis_b;
				ang_before=ang_b;
				dis_before=dis_b;

				warning_point=4;
				break;
	
			case 5:
				if((90-ang_cent_a+ang_now) > 180){
					ang_b_d=360-(90-ang_cent_a+ang_now);
				}
				if((90-ang_cent_a+ang_now) < 180){
					ang_b_d=90-ang_cent_a+ang_now;
				}
				if((90-ang_cent_a+ang_now) == 180){
					ang_b_d=90-ang_cent_a+ang_now;
				}
				dis_b=sqrt(pow(dis_before,2)+pow(dis_now,2)-2*dis_now*dis_before*cos(ang_b_d*3.1415927/180));
				ang_b=asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;

				ang_cent=180-ang_b_d-asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;

				if((90-ang_cent_a+ang_now) > 180){
					ang_b=360-ang_before+ang_b;
					ang_cent=(-1)*ang_cent;
				}
				if((90-ang_cent_a+ang_now) < 180){
					ang_b=360-ang_before-ang_b;
					ang_cent=ang_cent;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b=180;
					ang_cent=0;
				}
				
				post_ang_dumy[search_try_count-1]=ang_b;
				post_dis_dumy[search_try_count-1]=dis_b;
				ang_before=ang_b;
				dis_before=dis_b;

				warning_point=4;
				break;

			/***** 3rd quadrant *****/
			case 6:
				if((ang_cent_a+ang_now) > 180){
					ang_b_d=360-(ang_cent_a+ang_now);
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				dis_b=sqrt(pow(dis_before,2)+pow(dis_now,2)-2*dis_now*dis_before*cos(ang_b_d*3.1415927/180));
				ang_b=ang_before+asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;
	
				ang_cent=180-asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;
				
				post_ang_dumy[search_try_count-1]=ang_b;
				post_dis_dumy[search_try_count-1]=dis_b;
				ang_before=ang_b;
				dis_before=dis_b;

				if((ang_cent_a+ang_now) > 180){
					ang_b=ang_before-ang_b;
					ang_cent=ang_cent;
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b=ang_before+ang_b;
					ang_cent=(-1)*ang_cent;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b=180;
					ang_cent=0;
				}

				warning_point=4;
				break;

			case 7:
				if((ang_cent_a+ang_now) > 180){
					ang_b_d=360-(ang_cent_a+ang_now);
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				dis_b=sqrt(pow(dis_before,2)+pow(dis_now,2)-2*dis_now*dis_before*cos((ang_cent_a+ang_now)*3.1415927/180));
				ang_b=ang_before+asin(dis_now*sin((ang_cent_a+ang_now)*3.1415927/180)/dis_b)*180/3.1415927;

				ang_cent=180-ang_cent_a-ang_now-asin(dis_now*sin((ang_cent_a+ang_now)*3.1415927/180)/dis_b)*180/3.1415927;
			
				post_ang_dumy[search_try_count-1]=ang_b;
				post_dis_dumy[search_try_count-1]=dis_b;
				ang_before=ang_b;
				dis_before=dis_b;

				if((ang_cent_a+ang_now) > 180){
					ang_b=ang_before-ang_b;
					ang_cent=ang_cent;
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b=ang_before+ang_b;
					ang_cent=(-1)*ang_cent;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b=180;
					ang_cent=0;
				}

				warning_point=0;
				break;

			case 8:
				if((ang_cent_a+ang_now) > 180){
					ang_b_d=360-(ang_cent_a+ang_now);
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				dis_b=sqrt(pow(dis_before,2)+pow(dis_now,2)-2*dis_now*dis_before*cos((ang_cent_a+ang_now)*3.1415927/180));
				ang_b=ang_before+asin(dis_now*sin((ang_cent_a+ang_now)*3.1415927/180)/dis_b)*180/3.1415927;

				ang_cent=180-ang_cent_a-ang_now-asin(dis_now*sin((ang_cent_a+ang_now)*3.1415927/180)/dis_b)*180/3.1415927;
			
				post_ang_dumy[search_try_count-1]=ang_b;
				post_dis_dumy[search_try_count-1]=dis_b;
				ang_before=ang_b;
				dis_before=dis_b;

				if((ang_cent_a+ang_now) > 180){
					ang_b=ang_before-ang_b;
					ang_cent=ang_cent;
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b=ang_before+ang_b;
					ang_cent=(-1)*ang_cent;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b=180;
					ang_cent=0;
				}

				warning_point=4;
				break;
	
			/***** 4th quadrant *****/
			case 9:
				if((ang_cent_a+ang_now) > 180){
					ang_b_d=360-(ang_cent_a+ang_now);
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				dis_b=sqrt(pow(dis_before,2)+pow(dis_now,2)-2*dis_now*dis_before*cos(ang_b_d*3.1415927/180));
				ang_b=360-ang_before-asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;

				ang_cent=180-ang_b_d-asin(dis_now*sin(ang_b_d*3.1415927/180)/dis_b)*180/3.1415927;
			
				post_ang_dumy[search_try_count-1]=ang_b;
				post_dis_dumy[search_try_count-1]=dis_b;
				ang_before=ang_b;
				dis_before=dis_b;

				if((ang_cent_a+ang_now) > 180){
					ang_b=360-ang_before+ang_b;
					ang_cent=(-1)*ang_cent;
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b=360-ang_before-ang_b;
					ang_cent=ang_cent;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b=180;
					ang_cent=0;
				}

				warning_point=4;
				break;

			case 10:
				if((ang_cent_a+ang_now) > 180){
					ang_b_d=360-(ang_cent_a+ang_now);
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				dis_b=sqrt(pow(dis_before,2)+pow(dis_now,2)-2*dis_now*dis_before*cos((ang_cent_a+ang_now)*3.1415927/180));
				ang_b=360-ang_before-asin(dis_now*sin((ang_cent_a+ang_now)*3.1415927/180)/dis_b)*180/3.1415927;

				ang_cent=180-ang_cent_a-ang_now-asin(dis_now*sin((ang_cent_a+ang_now)*3.1415927/180)/dis_b)*180/3.1415927;
			
				post_ang_dumy[search_try_count-1]=ang_b;
				post_dis_dumy[search_try_count-1]=dis_b;
				ang_before=ang_b;
				dis_before=dis_b;

				if((ang_cent_a+ang_now) > 180){
					ang_b=360-ang_before+ang_b;
					ang_cent=(-1)*ang_cent;
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b=360-ang_before-ang_b;
					ang_cent=ang_cent;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b=180;
					ang_cent=0;
				}

				warning_point=4;
				break;

			case 11:
				if((ang_cent_a+ang_now) > 180){
					ang_b_d=360-(ang_cent_a+ang_now);
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b_d=ang_cent_a+ang_now;
				}
				dis_b=sqrt(pow(dis_before,2)+pow(dis_now,2)-2*dis_now*dis_before*cos((ang_cent_a+ang_now)*3.1415927/180));
				ang_b=360-ang_before-asin(dis_now*sin((ang_cent_a+ang_now)*3.1415927/180)/dis_b)*180/3.1415927;

				ang_cent=180-ang_cent_a-ang_now-asin(dis_now*sin((ang_cent_a+ang_now)*3.1415927/180)/dis_b)*180/3.1415927;
			
				post_ang_dumy[search_try_count-1]=ang_b;
				post_dis_dumy[search_try_count-1]=dis_b;
				ang_before=ang_b;
				dis_before=dis_b;

				if((ang_cent_a+ang_now) > 180){
					ang_b=360-ang_before+ang_b;
					ang_cent=(-1)*ang_cent;
				}
				if((ang_cent_a+ang_now) < 180){
					ang_b=360-ang_before-ang_b;
					ang_cent=ang_cent;
				}
				if((ang_cent_a+ang_now) == 180){
					ang_b=180;
					ang_cent=0;
				}

				warning_point=4;
				break;

			default:
				warning_point=0;
				break;
		}
	}

	return 0;
}
