#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "func_extern.h"
#include "uss.h"

int initialize(){
	int i;
	if ((fd0 = open("/dev/rtf2", O_RDONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf2\n");
		exit(1);
	}
	if ((fd1 = open("/dev/rtf3", O_RDONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf3\n");
		exit(1);
	}
	if ((fd2 = open("/dev/rtf4", O_WRONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf4\n");
		exit(1);
	}
	if ((fd3 = open("/dev/rtf5", O_WRONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf5\n");
		exit(1);
	}
	if ((fd5 = open("/dev/lcd", O_RDWR)) < 0) {
		fprintf(stderr, "Error opening /dev/lcd\n");
		exit(1);
	}
	if ((ctl = open("/dev/rtf1", O_WRONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf1\n");
		exit(1);
	}

	pthread_attr_init (&attr_irs_ts_ws);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_irs_ts_ws, SCHED_RR);
	pthread_attr_setschedparam (&attr_irs_ts_ws, &sched_param);

	pthread_attr_init (&attr_encoder);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_encoder, SCHED_RR);
	pthread_attr_setschedparam (&attr_encoder, &sched_param);

	pthread_attr_init (&attr_uss);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_uss, SCHED_RR);
	pthread_attr_setschedparam (&attr_uss, &sched_param);

	pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws, &irs_ts_ws, (void *)1);
	pthread_create(&encoder_task, &attr_encoder, &encoder, (void *)1);

	for(i=0;i<10;i++){
		post.ang[i]=0;
		post.dis[i]=0;
		post.got_post[i]=0;
		post.code[i]=0;
	}

	post.got_code=0;
	post.got_number=0;
	post.number=0;

	for(i=0;i<10;i++){
		post_tmp.ang[i]=0;
		post_tmp.dis[i]=0;
	}

	for(i=0;i<4;i++){
		irs[i] = '0';
		ts[i] = '0';
		ws[i] = '0';
	}

	irs_flag=0;
	ts_flag=0;
	ws_flag=0;
	uss_data=0;


/*personal variable or array*/

	for(i=0;i<1000;i++){
		dis_info[i]=0;
		ang_info[i]=0;
		dis_info2[i]=0;
		ang_info2[i]=0;
	}
	for(i=0;i<100;i++){
		dis_select[i]=0;
		ang_select[i]=0;
		post_dis_dumy[i]=0;
		post_ang_dumy[i]=0;
	}
	for(i=0;i<5;i++){
		post_number_code[i]=10;
		ang_rs_i[i]=0;
		dis_rs_i[i]=0;
		short_ang_rs_i[i]=0;
		post_dis[i]=0;
		post_ang[i]=0;
		short_dis[i]=0;
		short_ang[i]=0;
		post_ang_i[i]=0;
		short_ang_i[i]=0;
		m_s_dis[i]=0;
		m_s_ang[i]=0;
	}
	for(i=0;i<7;i++){
		found_post[7]=0;
	}
	warning_point=0;
	angle_now=0.0;
	ang_now=0;
	dis_now=0;
	ang_before=0;
	dis_before=0;
	search_post=0;
	ang_now_1st=0;
	search_try_count=0;
	sure=0;
	search_try_sure=0;
	kosuu=0;
	ang_approach=0;
	dis_approach=0;
	a_route_sel=0;
	b_route_sel=0;
	c_route_sel=0;
	d_route_sel=0;
	e_route_sel=0;
	a_route=0;
	b_route=0;
	c_route=0;
	d_route=0;
	e_route=0;
	a_route_s=0;
	b_route_s=0;
	c_route_s=0;
	d_route_s=0;
	e_route_s=0;
	sure=0;
	flag_calculated=0;
	s_number=0;
	ang_cent=0;
	ang_cent_a=0;
	pass_flag=0;

	return 0;

}

