#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"
#include "led.h"

//DEFINE SENSORS
#define IRS_FRONT	0
#define IRS_LEFT	1

//DEFINE TIME&DIS&ANG
#define TURN_TIME	2000
#define DETECTING_TIME	20000
#define SLEEP_TIME	200000
#define PUSH_TIME	3000
#define IRS_SLEEP1	300000
#define IRS_SLEEP2	700000
#define PWM_SLEEP	20000
#define LOOP_SLEEP	1000

//OTHER DEFINE
#define RETRY_NUMBER	8

int ioperm(unsigned long from, unsigned long num, int turn_on);

int post_get0702_3(int target_post){
	int rot_diff=0;
	int rot_cur=0;
	int rot_cur2=0;
	int rot_cur2b=0;
	int retry_num=0;
	int dis2=0;
	int circle_radious2=circle_radious;
	int fwd_dis=0,back_dis=0;
	int rot_time=0;
	int ts_on=0;
	int get_code=0;
	int ir_code=0;
	int uss_1=0,uss_2=0,uss_fr=0,uss_retry_count=0;
	int irs_on=0;
	int irs_count;
	int i=0;
	int y=0;	/*count for correct irs value*/
	int irs_select[6];
	int irs_value=0;
	int cent_time=0;

	ioperm(PORT,1,1);

	outb(FLASH2,PORT);
	usleep(1000);

	kosuu=0;

	for(y=0;y<6;y++){
		irs_select[y]=0;
	}

	printf("Start post_get\n\n");

	lqr_rotate(-(int)(90*ANGLE_DIFF),TURN_TIME);
	usleep(SLEEP_TIME);

	if(warning_point==4){
		cent_time=abs(ang_cent*55);
		lqr_circle(circle_radious2, (int)(ang_cent*ANGLE_DIFF2),cent_time);
		usleep(SLEEP_TIME);
	}	
		
	// Start encoder task with period of 10msec
	printf("Start encoder task.\n");
	pwm_enco_start(10);
	usleep(PWM_SLEEP);


	printf("Go arround target post\n");

	pwm_lqr_circle(circle_radious2, (int)((AROUND_ANG+10)*ANGLE_DIFF2),DETECTING_TIME);
	
	count.br=0;
	while(1){
		ir_code=irs_code_get(IRS_LEFT);
		uss_1=uss_get(1); 
		uss_2=uss_get(2);
		uss_fr=(int)((uss_1+uss_2)/2+0.5);
		rot_cur2=(int)(90/pi*(alw+arw)/circle_radious2);
		if(rot_cur2-rot_cur2b>=1){
			dis_info[i]=uss_fr;
			ang_info[i]=rot_cur2/ANGLE_DIFF2;
			rot_cur2b=rot_cur2;
			rot_diff=rot_cur2;
			kosuu++;
			i++;
		}
		if(ir_code!=0){

			usleep(IRS_SLEEP1);
			rot_cur=(int)(90/pi*(alw+arw)/circle_radious2);
			pwm_both_data(0,0);
			usleep(PWM_SLEEP);
			printf("Stop encoder task.\n");
			pwm_enco_stop();
			usleep(PWM_SLEEP);
			break;
		}

		if(count.br==1) {
			pwm_both_data(0,0);
			usleep(PWM_SLEEP);
			pwm_enco_stop();
			usleep(PWM_SLEEP);
			printf("\n***********IRS was not detected.***********\n\n");
			goto BY2;
		}
	}

	printf("irs find!\n");

	printf("rot_cur=%d \n",rot_cur);

	if(pass_flag==1){
		goto NEXT;
	}

	for(y=0;y<5;y++){				/*Get irs 5times*/
		irs_value=irs_code_get(IRS_LEFT);
		irs_select[irs_value]++;
		usleep(50000);
	}

		
	for(y=0;y<6;y++){
		if(irs_select[y]>=3){
			get_code = y;
			break;
		}
	}

	post_number_code[sure-1]=get_code;
	found_post[get_code]=1;

	if(get_code==target_post){
		if(found_post[target_post+1]==1){
			pass_flag=1;
		}
		goto NEXT;
	}	

        goto BY;	/*BY*/

NEXT:

	lqr_rotate((int)(90*ANGLE_DIFF),TURN_TIME);
	usleep(SLEEP_TIME);

	retry_num=1;
	while(retry_num<RETRY_NUMBER){
		ts_on=0;
		irs_on=0;

		uss_retry_count=0;
		while(uss_retry_count<10){
			do{
				uss_1=uss_get(1);
				uss_2=uss_get(2);
				usleep(LOOP_SLEEP);
			}while (uss_1==0 || uss_2==0);
				if(abs(uss_1-uss_2)< 8){
					break;
				}else if(uss_1>uss_2){
					lqr_rotate(-(int)(8*ANGLE_DIFF),800);
				}else if(uss_1<uss_2){
					lqr_rotate((int)(8*ANGLE_DIFF),800);
				}
			usleep(LOOP_SLEEP);
			uss_retry_count++;
		}
		usleep(SLEEP_TIME);
		
		printf("\nretry_num=%d\n\n",retry_num);
		
		dis2=(170+30*retry_num);
		
		pwm_enco_start(10);
		usleep(PWM_SLEEP);
		pwm_lqr_straight(dis2,PUSH_TIME);
		usleep(PWM_SLEEP);
		count.br=0;
	
		while(1){
			if(count.br==1){
				break;
			}
			if(ts[0]=='1'|| ts[1]=='1'){
				usleep(IRS_SLEEP2);
				fwd_dis=(alw+arw)/2;
				ts_on=1;
				break;
			}
			usleep(LOOP_SLEEP);
		}
		pwm_both_data(0,0);
		usleep(PWM_SLEEP);
		pwm_enco_stop();
		usleep(PWM_SLEEP);
		printf("\nfwd_dis=%d\n",fwd_dis);

		usleep(SLEEP_TIME);
		if(fwd_dis!=0){
			back_dis=(-1*fwd_dis);
		}else{
			back_dis=(-1*dis2);
		}

		printf("back_dis=%d\n\n",back_dis);

		lqr_straight(back_dis,back_dis*4);
		usleep(SLEEP_TIME);

			if(irs[IRS_FRONT]=='1'){
		for(irs_count=0;irs_count<300;irs_count++){
				irs_on=1;
			}
			usleep(LOOP_SLEEP);
		}
		
		if(ts_on==1 && irs_on==0){
			printf("\nGetting post was success!!!\n");

			target_post++;
			usleep(SLEEP_TIME);
			break;
		}else if(ts_on!=1){
			printf("\nGetting post was failed.  ts_on==%d\n\n",ts_on);

		}else if(irs_on!=0){
			printf("\nGetting post was failed.  irs_on==%d\n\n",irs_on);

		}

		if(retry_num==RETRY_NUMBER){
				printf("\nretry_num is max. So retry is end.\n");

		}
		retry_num++;
	}
	circle_position(); 

	lqr_rotate(-(int)(90*ANGLE_DIFF),TURN_TIME);

BY:
	printf("Start encoder task.\n");
	pwm_enco_start(10);
	usleep(PWM_SLEEP);
	
	printf("move to start_circle\n");

	rot_time = (AROUND_ANG-rot_cur)*55;
	pwm_lqr_circle(circle_radious2,(int)((AROUND_ANG+10-rot_cur)*ANGLE_DIFF2),rot_time);
	count.br=0;	
	while(1){
		uss_1=uss_get(1);
		uss_2=uss_get(2);
		uss_fr=(int)((uss_1+uss_2)/2+0.5);
		rot_cur2=(int)(90/pi*(alw+arw)/circle_radious2);
		if(rot_cur2-rot_cur2b>=1){
			dis_info[i]=uss_fr;
			ang_info[i]=(rot_cur2+rot_cur)/ANGLE_DIFF2;
			rot_cur2b=rot_cur2;
			kosuu++;
			i++;
		}	
		if(count.br==1) {
			pwm_both_data(0,0);
			usleep(PWM_SLEEP);
			pwm_enco_stop();
			usleep(PWM_SLEEP);
			break;
		}
	}
	usleep(SLEEP_TIME);
	printf("returned to start_circle\n\n");
	printf("finished post_get().\n\n");

	fclose(fa);
	fclose(ff);

	outb(STOP,PORT);
	usleep(1000);

	return target_post;

BY2:
	usleep(SLEEP_TIME);
	printf("returned to start_circle\n\n");
	printf("finished post_get().\n\n");

	outb(STOP,PORT);
	usleep(1000);

	return target_post;
}
