#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>
#include <string.h>
#include <asm/io.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "control.h"
#include "func_extern.h"
#include "rotation.h"
#include "uss.h"
#include "pwm_enc.h"
#include "led.h"

int ioperm(unsigned long from, unsigned long num, int turn_on);

int rot1(double rot_angle,int rot_direction){
	
	double s = 0.375;
	double d = 0.0;
	int rot_count = 0;
	int i;
	if(rot_direction!=0 && rot_direction!=1 ){
		printf("rot_direction input error\n");
		goto owari;
	}
	if(rot_angle<-360.0 || rot_angle>360.0 ){
		printf("rot_direction input error\n");
		goto owari;
	}
	if(rot_direction==1){
		rot_angle=-rot_angle;
	}

	if(angle_now>rot_angle){
		rot_direction=1;
		if(angle_now>0){
			if(rot_angle>=0){
				rot_angle=fabs(angle_now)-rot_angle;
			}else{
				rot_angle=angle_now+fabs(rot_angle);
			}
		}else{
			rot_angle=fabs(rot_angle)-fabs(angle_now);
		}
	}else if(angle_now<rot_angle){
		rot_direction=0;
		if(angle_now>=0){
			rot_angle=rot_angle-fabs(angle_now);
		}else{
			if(rot_angle>0){
				rot_angle=fabs(angle_now)+rot_angle;
			}else{
				rot_angle=fabs(angle_now)-rot_angle;
			}
		}
	}else{
		goto owari;
	}

	if(rot_angle<0){
		rot_angle=-rot_angle;
	}
	d = fmod(rot_angle,s);	
	rot_count = rot_angle / 0.375;
	
	if( d >= 0.1875 ){
		rot_count++;
	}
	
	ioperm(rot_port,1,1);	
	ioperm(PORT,1,1);
	
	outb(FLASH4,PORT);
	usleep(1000);

	switch (rot_direction){
		case 0:
			for(i=0;i<rot_count;i++){
				angle_now=angle_now+0.375;
				if(angle_now>360.0){
					angle_now=angle_now-0.375;
					goto owari;
				}
				outb(rot_right,rot_port);
				usleep(RB_TIME);
				outb(rot_stop,rot_port);
				usleep(RB_TIME);
			}
			break;
		case 1:
			for(i=0;i<rot_count;i++){
				angle_now=angle_now-0.375;
				if(angle_now<-360.0){
					angle_now=angle_now+0.375;
					goto owari;
				}
				outb(rot_left,rot_port);
				usleep(RB_TIME);
				outb(rot_stop,rot_port);
				usleep(RB_TIME);
			}
			break;
		default:break;
	}
owari:
	outb(STOP,PORT);
	usleep(1000);

	printf("angle=%f\n",angle_now);
	printf("Rotation END\n");
	return 0;
}

int rot2(double rot_angle,int rot_direction){
	double ang_info_i[1000];

	double d = 0.0;
	int rot_count = 0;
	int i;
	double s = 0.375;
	int uss_code1 = 4;
	int uss_code2 = 6;
	int uss_obt1 = 0;
	int uss_obt2 = 0;
	int uss_avr = 0;
	
	kosuu=0;

	if(rot_direction==1){
		rot_angle=-rot_angle;
	}
	
	if(angle_now>rot_angle){
		rot_direction=1;
		if(angle_now>0){
			if(rot_angle>=0){
				rot_angle=fabs(angle_now)-rot_angle;
			}else{
				rot_angle=angle_now+fabs(rot_angle);
			}
		}else{
			rot_angle=fabs(rot_angle)-fabs(angle_now);
		}
	}else if(angle_now<rot_angle){
		rot_direction=0;
		if(angle_now>=0){
			rot_angle=rot_angle-fabs(angle_now);
		}else{
			if(rot_angle>0){
				rot_angle=fabs(angle_now)+rot_angle;
			}else{
				rot_angle=fabs(angle_now)-rot_angle;
			}
		}
	}else{
		goto owari2;
	}



	if(rot_angle<0){
		rot_angle=-rot_angle;
	}

	d = fmod(rot_angle,s);
	rot_count = rot_angle / 0.375;
	
	if( d >= 0.1875 ){
		rot_count++;
	}
	
	ioperm(rot_port,1,1);
	ioperm(PORT,1,1);
	
	outb(FLASH4,PORT);
	usleep(1000);
	
	switch (rot_direction){
		case 0:
			for(i=0;i<rot_count;i++){
				if(angle_now<0){
					ang_info_i[i] =-angle_now;
				}else if(angle_now>0){
					ang_info_i[i] = 360-angle_now;
				}else{
					ang_info_i[i] = 0;
				}
				if((i%15)==0 || i==0){
					uss_obt1 = uss_get(uss_code1);
					uss_obt2 = uss_get(uss_code2);
					if( uss_obt1 >= USS_MAX && uss_obt1 <= USS_MIN ){
						uss_obt1=9999;
					}
					if( uss_obt2 >= USS_MAX && uss_obt2 <= USS_MIN ){
						uss_obt2=9999;
			    		}

					uss_avr=(uss_obt1+uss_obt2)/2;
					kosuu++;
					ang_info[kosuu]=ang_info_i[i];
			   		dis_info[kosuu]=uss_avr; 
				}
			    
				angle_now=angle_now+0.375;
				if(angle_now>360.0){
					angle_now=angle_now-0.375;
					goto owari2;
				}
				outb(rot_right,rot_port);
				usleep(RB_TIME);
				outb(rot_stop,rot_port);
				usleep(RB_TIME);
			}
			break;
		case 1:
			for(i=0;i<rot_count;i++){
				if(angle_now<0){
					ang_info_i[i] =-angle_now;
				}else if(angle_now>0){
					ang_info_i[i] = 360-angle_now;
				}else{
					ang_info_i[i] = 0;
				}
				if((i%15)==0 || i==0){
					uss_obt1 = uss_get(uss_code1);
					uss_obt2 = uss_get(uss_code2);
					if( uss_obt1 >= USS_MAX && uss_obt1 <= USS_MIN ){
						uss_obt1=9999;
					}
					if( uss_obt2 >= USS_MAX && uss_obt2 <= USS_MIN ){
						uss_obt2=9999;
			    		}

				    	uss_avr=(uss_obt1+uss_obt2)/2;
				    	kosuu++;
			   		dis_info[kosuu]=uss_avr; 
					ang_info[kosuu]=ang_info_i[i];
				}				
				
				angle_now=angle_now-0.375;
				if(angle_now<-360.0){
					angle_now=angle_now+0.375;
					goto owari2;
				}
				outb(rot_left,rot_port);
				usleep(RB_TIME);
				outb(rot_stop,rot_port);
				usleep(RB_TIME);

			}
			break;
		default:break;
	}
owari2: 
	outb(STOP,PORT);
	usleep(1000);

	printf("angle=%f\n",angle_now);
	printf("The Number of Infomation : %d \n",kosuu);

	return 0;
}

