#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <math.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"
#include "rotation.h"
#include "led.h"

#define PWM_SLEEP	20000
#define DETECTING_TIME2	5000

/***** caluculate distance bitween post to start point *****/
int route1(){

	double dis;
	
	switch (search_try_sure){
		case 1:
			short_dis[0]=post_dis[0];
			short_ang[0]=post_ang[0];
			break;
		case 2:
			if(post_ang[1] > 180){
				post_ang_i[1]=360-post_ang[1];
			}
			if(post_ang[1] < 180){
				post_ang_i[1]=post_ang[1];
			}
			if(post_ang[1] == 180){
				post_ang_i[1]=post_ang[1];
			}
			short_dis[1]=sqrt(pow(short_dis[0],2)+pow(post_dis[1],2)-2*short_dis[0]*post_dis[1]*cos(post_ang_i[1]*3.1415927/180));
			short_ang_i[1]=asin(post_dis[1]*sin(post_ang_i[1]*3.1415927/180)/short_dis[1])*180/3.1415927;
			a_route_s=short_ang_i[1];
			dis=sqrt(pow(short_dis[0],2)+pow(short_dis[1],2)-2*short_dis[0]*short_dis[1]*cos(short_ang_i[1]*3.1415927/180));
			if(dis > post_dis[1]*0.95){
				if(post_ang[1] < 180){
					short_ang[1]=short_ang[0]-short_ang_i[1];
				}
				if(post_ang[1] > 180){
					short_ang[1]=short_ang[0]+short_ang_i[1];
				}
				if(post_ang[1] == 180){
					short_ang[1]=short_ang[0];
				}
			}
			break;
		case 3:
			if(post_ang[2] < 180 && post_ang[1] < 180){
				a_route=post_ang[2]-(180-post_ang_i[1]-short_ang_i[1]);
				post_ang_i[2]=a_route;
			}
			if(post_ang[2] < 180 && post_ang[1] > 180){
				a_route=post_ang[2]+(180-post_ang_i[1]-short_ang_i[1]);
				post_ang_i[2]=a_route;
			}
			if(post_ang[2] > 180 && post_ang[1] > 180){
				a_route=360-(post_ang[2]+(180-post_ang_i[1]-short_ang_i[1]));
				post_ang_i[2]=360-a_route;
			}
			if(post_ang[2] > 180 && post_ang[1] < 180){
				a_route=360-(post_ang[2]-(180-post_ang_i[1]-short_ang_i[1]));
				post_ang_i[2]=360-a_route;
			}
			short_dis[2]=sqrt(pow(short_dis[1],2)+pow(post_dis[2],2)-2*short_dis[1]*post_dis[2]*cos(a_route*3.1415927/180));
			short_ang_i[2]=asin(post_dis[2]*sin(a_route*3.1415927/180)/short_dis[2])*180/3.1415927;
			b_route_s=short_ang_i[2];
			dis=sqrt(pow(short_dis[1],2)+pow(short_dis[2],2)-2*short_dis[1]*short_dis[2]*cos(short_ang_i[2]*3.1415927/180));
			if(dis > post_dis[2]*0.95){
				if(post_ang_i[2] < 180){
					short_ang[2]=short_ang[1]-short_ang_i[2];
				}
				if(post_ang_i[2] > 180){
					short_ang[2]=short_ang[1]+short_ang_i[2];
				}
				if(post_ang_i[2] == 180){
					short_ang[2]=short_ang[1];
				}
			}
			break;
		case 4:
			if(post_ang[3] < 180 && post_ang[2] < 180){
				b_route=post_ang[3]-(180-a_route-short_ang_i[2]);
				post_ang_i[3]=b_route;
			}
			if(post_ang[3] < 180 && post_ang[2] > 180){
				b_route=post_ang[3]+(180-a_route-short_ang_i[2]);
				post_ang_i[3]=b_route;
			}
			if(post_ang[3] > 180 && post_ang[2] > 180){
				b_route=360-(post_ang[3]+(180-a_route-short_ang_i[2]));
				post_ang_i[3]=360-b_route;
			}
			if(post_ang[3] > 180 && post_ang[2] < 180){
				b_route=360-(post_ang[3]-(180-a_route-short_ang_i[2]));
				post_ang_i[3]=360-b_route;
			}
			short_dis[3]=sqrt(pow(short_dis[2],2)+pow(post_dis[3],2)-2*short_dis[2]*post_dis[3]*cos(b_route*3.1415927/180));
			short_ang_i[3]=asin(post_dis[3]*sin(b_route*3.1415927/180)/short_dis[3])*180/3.1415927;
			c_route_s=short_ang_i[3];
			dis=sqrt(pow(short_dis[2],2)+pow(short_dis[3],2)-2*short_dis[2]*short_dis[3]*cos(short_ang_i[3]*3.1415927/180));
			if(dis > post_dis[3]*0.95){
				if(post_ang_i[3] < 180){
					short_ang[3]=short_ang[2]-short_ang_i[3];
				}
				if(post_ang_i[3] > 180){
					short_ang[3]=short_ang[2]+short_ang_i[3];
				}
				if(post_ang_i[3] == 180){
					short_ang[3]=short_ang[2];
				}
			}
			break;
		case 5:
			if(post_ang[4] < 180 && post_ang[3] < 180){
				c_route=post_ang[4]-(180-b_route-short_ang_i[3]);
				post_ang_i[4]=c_route;
			}
			if(post_ang[4] < 180 && post_ang[3] > 180){
				c_route=post_ang[4]+(180-b_route-short_ang_i[3]);
				post_ang_i[4]=c_route;
			}
			if(post_ang[4] > 180 && post_ang[3] > 180){
				c_route=360-(post_ang[4]+(180-b_route-short_ang_i[3]));
				post_ang_i[4]=360-c_route;
			}
			if(post_ang[4] > 180 && post_ang[3] < 180){
				c_route=360-(post_ang[4]-(180-b_route-short_ang_i[3]));
				post_ang_i[4]=360-c_route;
			}
			short_dis[4]=sqrt(pow(short_dis[3],2)+pow(post_dis[4],2)-2*short_dis[3]*post_dis[4]*cos(c_route*3.1415927/180));
			short_ang_i[4]=asin(post_dis[4]*sin(c_route*3.1415927/180)/short_dis[4])*180/3.1415927;
			d_route_s=short_ang_i[4];
			dis=sqrt(pow(short_dis[3],2)+pow(short_dis[4],2)-2*short_dis[3]*short_dis[4]*cos(short_ang_i[4]*3.1415927/180));
			if(dis > post_dis[4]*0.95){
				if(post_ang_i[4] < 180){
					short_ang[4]=short_ang[3]-short_ang_i[4];
				}
				if(post_ang_i[4] > 180){
					short_ang[4]=short_ang[3]+short_ang_i[4];
				}
				if(post_ang_i[4] == 180){
					short_ang[4]=short_ang[3];
				}
			}
			break;
		default:break;
	}
	
	printf("Short_Disance_Caluculate END\n");

	return 0;
}


/***** caluculate shortest_route *****/
int route2(){

	double m_s_ang_i[5]={0,0,0,0,0};
	double ang[5]={0,0,0,0,0};
	double dis;

	double min=0.0;
	int j,k,dumy_number,s;
	double dumy_dis,dumy_ang;

	for(j=0;j<search_try_sure;j++){
		min=post_number_code[j];
		s=j;
		for(k=j+1;k<search_try_sure;k++){
			if(post_number_code[k]<min){
				min=post_number_code[k];
				s=k;
			}
		}
		dumy_number=post_number_code[j];
		post_number_code[j]=post_number_code[s];
		post_number_code[s]=dumy_number;

		dumy_dis=short_dis[j];
		short_dis[j]=short_dis[s];
		short_dis[s]=dumy_dis;

		dumy_ang=short_ang[j];
		short_ang[j]=short_ang[s];
		short_ang[s]=dumy_ang;
	}

	/*Phase1*/
	m_s_dis[0]=short_dis[0];
	m_s_ang[0]=short_ang[0];
	if(search_try_sure==1){
		goto LAST;
	}

	/*Phase2*/
	if(short_ang[0]-short_ang[1] < 0){
		ang[1]=(-1)*(short_ang[0]-short_ang[1]);
	}else{
		ang[1]=short_ang[0]-short_ang[1];
	}
	m_s_dis[1]=sqrt(pow(short_dis[0],2)+pow(short_dis[1],2)-2*short_dis[0]*short_dis[1]*cos(ang[1]*3.1415927/180));
	m_s_ang_i[1]=asin(short_dis[1]*sin(ang[1]*3.1415927/180)/m_s_dis[1])*180/3.1415927;
	dis=sqrt(pow(m_s_dis[1],2)+pow(short_dis[0],2)-2*short_dis[0]*m_s_dis[1]*cos(m_s_ang_i[1]*3.1415927/180));
	if(dis > short_dis[1]*0.95){
		if(short_ang[0]-short_ang[1] > 0){
			m_s_ang[1]=m_s_ang_i[1];
		}
		if(short_ang[0]-short_ang[1] < 0){
			m_s_ang[1]=360-m_s_ang_i[1];
		}
	}else{
		if(short_ang[0]-short_ang[1] > 0){
			m_s_ang[1]=180-m_s_ang_i[1];
			m_s_ang_i[1]=m_s_ang[1];
		}
		if(short_ang[0]-short_ang[1] < 0){
			m_s_ang[1]=360-(180-m_s_ang_i[1]);
			m_s_ang_i[1]=360-m_s_ang[1];
		}
	}
	if(search_try_sure==2){
		goto LAST;
	}

	/*Phase3*/
	if(short_ang[1]-short_ang[2] < 0){
		ang[2]=(-1)*(short_ang[1]-short_ang[2]);
	}else{
		ang[2]=short_ang[1]-short_ang[2];
	}
	m_s_dis[2]=sqrt(pow(short_dis[1],2)+pow(short_dis[2],2)-2*short_dis[1]*short_dis[2]*cos(ang[2]*3.1415927/180));
	m_s_ang_i[2]=asin(short_dis[2]*sin(ang[2]*3.1415927/180)/m_s_dis[2])*180/3.1415927;
	dis=sqrt(pow(m_s_dis[2],2)+pow(short_dis[1],2)-2*short_dis[1]*m_s_dis[2]*cos(m_s_ang_i[2]*3.1415927/180));
	if(dis > short_dis[2]*0.95){
		if(short_ang[1]-short_ang[2] > 0 && short_ang[0]-short_ang[1] > 0){
			m_s_ang[2]=m_s_ang_i[2]+(180-ang[1]-m_s_ang_i[1]);
		}
		if(short_ang[1]-short_ang[2] > 0 && short_ang[0]-short_ang[1] < 0){
			m_s_ang[2]=m_s_ang_i[2]-(180-ang[1]-m_s_ang_i[1]);
		}
		if(short_ang[1]-short_ang[2] < 0 && short_ang[0]-short_ang[1] > 0){
			m_s_ang[2]=360-m_s_ang_i[2]+(180-ang[1]-m_s_ang_i[1]);
			m_s_ang_i[2]=360-m_s_ang[2];
		}
		if(short_ang[1]-short_ang[2] < 0 && short_ang[0]-short_ang[1] < 0){
			m_s_ang[2]=360-m_s_ang_i[2]-(180-ang[1]-m_s_ang_i[1]);
			m_s_ang_i[2]=360-m_s_ang[2]-(180-ang[1]-m_s_ang_i[1]);
		}
	}else{
		if(short_ang[1]-short_ang[2] > 0 && short_ang[0]-short_ang[1] > 0){
			m_s_ang[2]=(180-m_s_ang_i[2])+(180-ang[1]-m_s_ang_i[1]);
			m_s_ang_i[2]=m_s_ang[2]-(180-ang[1]-m_s_ang_i[1]);
		}
		if(short_ang[1]-short_ang[2] > 0 && short_ang[0]-short_ang[1] < 0){
			m_s_ang[2]=(180-m_s_ang_i[2])-(180-ang[1]-m_s_ang_i[1]);
			m_s_ang_i[2]=m_s_ang[2]+(180-ang[1]-m_s_ang_i[1]);
		}
		if(short_ang[1]-short_ang[2] < 0 && short_ang[0]-short_ang[1] > 0){
			m_s_ang[2]=360-(180-m_s_ang_i[2])+(180-ang[1]-m_s_ang_i[1]);
			m_s_ang_i[2]=360-m_s_ang[2];
		}
		if(short_ang[1]-short_ang[2] < 0 && short_ang[0]-short_ang[1] < 0){
			m_s_ang[2]=360-(180-m_s_ang_i[2])-(180-ang[1]-m_s_ang_i[1]);
			m_s_ang_i[2]=360-m_s_ang[2]-(180-ang[1]-m_s_ang_i[1]);
		}
	}
	if(search_try_sure==3){
		goto LAST;
	}

	/*Phase4*/
	if(short_ang[2]-short_ang[3] < 0){
		ang[3]=(-1)*(short_ang[2]-short_ang[3]);
	}else{
		ang[3]=short_ang[2]-short_ang[3];
	}
	m_s_dis[3]=sqrt(pow(short_dis[2],2)+pow(short_dis[3],2)-2*short_dis[2]*short_dis[3]*cos(ang[3]*3.1415927/180));
	m_s_ang_i[3]=asin(short_dis[3]*sin(ang[3]*3.1415927/180)/m_s_dis[3])*180/3.1415927;
	dis=sqrt(pow(m_s_dis[3],2)+pow(short_dis[2],2)-2*short_dis[2]*m_s_dis[3]*cos(m_s_ang_i[3]*3.1415927/180));
	if(dis > short_dis[3]*0.95){
		if(short_ang[2]-short_ang[3] > 0 && short_ang[1]-short_ang[2] > 0){
			m_s_ang[3]=m_s_ang_i[3]+(180-ang[2]-m_s_ang_i[2]);
		}
		if(short_ang[2]-short_ang[3] > 0 && short_ang[1]-short_ang[2] < 0){
			m_s_ang[3]=m_s_ang_i[3]-(180-ang[2]-m_s_ang_i[2]);
		}
		if(short_ang[2]-short_ang[3] < 0 && short_ang[1]-short_ang[2] > 0){
			m_s_ang[3]=360-m_s_ang_i[3]+(180-ang[2]-m_s_ang_i[2]);
			m_s_ang_i[3]=360-m_s_ang[3];
		}
		if(short_ang[2]-short_ang[3] < 0 && short_ang[1]-short_ang[2] < 0){
			m_s_ang[3]=360-m_s_ang_i[3]-(180-ang[2]-m_s_ang_i[2]);
			m_s_ang_i[3]=360-m_s_ang[3]-(180-ang[2]-m_s_ang_i[2]);
		}
	}else{
		if(short_ang[2]-short_ang[3] > 0 && short_ang[1]-short_ang[2] > 0){
			m_s_ang[3]=(180-m_s_ang_i[3])+(180-ang[2]-m_s_ang_i[2]);
			m_s_ang_i[3]=m_s_ang[3]-(180-ang[2]-m_s_ang_i[2]);
		}
		if(short_ang[2]-short_ang[3] > 0 && short_ang[1]-short_ang[2] < 0){
			m_s_ang[3]=(180-m_s_ang_i[3])-(180-ang[2]-m_s_ang_i[2]);
			m_s_ang_i[3]=m_s_ang[3]+(180-ang[2]-m_s_ang_i[2]);
		}
		if(short_ang[2]-short_ang[3] < 0 && short_ang[1]-short_ang[2] > 0){
			m_s_ang[3]=360-(180-m_s_ang_i[3])+(180-ang[2]-m_s_ang_i[2]);
			m_s_ang_i[3]=360-m_s_ang[3];
		}
		if(short_ang[2]-short_ang[3] < 0 && short_ang[1]-short_ang[2] < 0){
			m_s_ang[3]=360-(180-m_s_ang_i[3])-(180-ang[2]-m_s_ang_i[2]);
			m_s_ang_i[3]=360-m_s_ang[3]-(180-ang[2]-m_s_ang_i[2]);
		}
	}
	if(search_try_sure==4){
		goto LAST;
	}

	/*Phase5*/
	if(short_ang[3]-short_ang[4] < 0){
		ang[4]=(-1)*(short_ang[3]-short_ang[4]);
	}else{
		ang[4]=short_ang[3]-short_ang[4];
	}
	m_s_dis[4]=sqrt(pow(short_dis[3],2)+pow(short_dis[4],2)-2*short_dis[3]*short_dis[4]*cos(ang[4]*3.1415927/180));
	m_s_ang_i[4]=asin(short_dis[4]*sin(ang[4]*3.1415927/180)/m_s_dis[4])*180/3.1415927;
	dis=sqrt(pow(m_s_dis[4],2)+pow(short_dis[3],2)-2*short_dis[3]*m_s_dis[4]*cos(m_s_ang_i[4]*3.1415927/180));
	if(dis > short_dis[4]*0.95){
		if(short_ang[3]-short_ang[4] > 0 && short_ang[2]-short_ang[3] > 0){
			m_s_ang[4]=m_s_ang_i[4]+(180-ang[3]-m_s_ang_i[3]);
		}
		if(short_ang[3]-short_ang[4] > 0 && short_ang[2]-short_ang[3] < 0){
			m_s_ang[4]=m_s_ang_i[4]-(180-ang[3]-m_s_ang_i[3]);
		}
		if(short_ang[3]-short_ang[4] < 0 && short_ang[2]-short_ang[3] > 0){
			m_s_ang[4]=360-m_s_ang_i[4]+(180-ang[3]-m_s_ang_i[3]);
			m_s_ang_i[4]=360-m_s_ang[4];
		}
		if(short_ang[3]-short_ang[4] < 0 && short_ang[2]-short_ang[3] < 0){
			m_s_ang[4]=360-m_s_ang_i[4]-(180-ang[3]-m_s_ang_i[3]);
			m_s_ang_i[4]=360-m_s_ang[4]-(180-ang[3]-m_s_ang_i[3]);
		}
	}else{
		if(short_ang[3]-short_ang[4] > 0 && short_ang[2]-short_ang[3] > 0){
			m_s_ang[4]=(180-m_s_ang_i[4])+(180-ang[3]-m_s_ang_i[3]);
			m_s_ang_i[4]=m_s_ang[4]-(180-ang[3]-m_s_ang_i[3]);
		}
		if(short_ang[3]-short_ang[4] > 0 && short_ang[2]-short_ang[3] < 0){
			m_s_ang[4]=(180-m_s_ang_i[4])-(180-ang[3]-m_s_ang_i[3]);
			m_s_ang_i[4]=m_s_ang[4]+(180-ang[3]-m_s_ang_i[3]);
		}
		if(short_ang[3]-short_ang[4] < 0 && short_ang[2]-short_ang[3] > 0){
			m_s_ang[4]=360-(180-m_s_ang_i[4])+(180-ang[3]-m_s_ang_i[3]);
			m_s_ang_i[4]=360-m_s_ang[4];
		}
		if(short_ang[3]-short_ang[4] < 0 && short_ang[2]-short_ang[3] < 00){
			m_s_ang[4]=360-(180-m_s_ang_i[4])-(180-ang[3]-m_s_ang_i[3]);
			m_s_ang_i[4]=360-m_s_ang[4]-(180-ang[3]-m_s_ang_i[3]);
		}
	}
	if(search_try_sure==5){
		goto LAST;
	}

LAST:
	printf("Route Caluculate END \n");
	
	return 0;
}


/***** false post or truth post *****/
int route3(double ang_rs,double dis_rs){

	double short_dis_prov=0.0;
	double short_ang_prov=0.0;
	double dis;
	double dis_sin,dis_cos;

	int value=0;

	switch (search_try_sure){
		case 1:
			if(ang_rs > 180){
				ang_rs_i[1]=360-ang_rs;
			}
			if(ang_rs < 180){
				ang_rs_i[1]=ang_rs;
			}
			if(ang_rs == 180){
				ang_rs_i[1]=ang_rs;
			}
			short_dis_prov=sqrt(pow(short_dis[0],2)+pow(dis_rs,2)-2*short_dis[0]*dis_rs*cos(ang_rs_i[1]*3.1415927/180));
			short_ang_rs_i[1]=asin(dis_rs*sin(ang_rs_i[1]*3.1415927/180)/short_dis_prov)*180/3.1415927;
			dis=sqrt(pow(short_dis[0],2)+pow(short_dis_prov,2)-2*short_dis[0]*short_dis_prov*cos(short_ang_rs_i[1]*3.1415927/180));
			if(dis > dis_rs*0.95){
				if(ang_rs < 180){
					short_ang_prov=short_ang[0]-short_ang_rs_i[1];
				}
				if(ang_rs > 180){
					short_ang_prov=short_ang[0]+short_ang_rs_i[1];
				}
				if(ang_rs == 180){
					short_ang_prov=short_ang[0];
				}
			}else{
				short_ang_rs_i[1]=180-short_ang_rs_i[1];
				if(ang_rs < 180){
					short_ang_prov=short_ang[0]-short_ang_rs_i[1];
				}
				if(ang_rs > 180){
					short_ang_prov=short_ang[0]+short_ang_rs_i[1];
				}
				if(ang_rs == 180){
					short_ang_prov=short_ang[0];
				}
			}

			dis_sin=short_dis_prov*sin(short_ang_prov*3.1415927/180);
			dis_cos=short_dis_prov*cos(short_ang_prov*3.1415927/180);
			if(((0<dis_sin && dis_sin<FIELD_DIAMETER)&&(0<dis_cos && dis_cos<FIELD_DIAMETER/2)) || ((0<dis_sin && dis_sin<FIELD_DIAMETER)&&(-FIELD_DIAMETER/2<dis_cos && dis_cos<0))){
				value=0;
			}else{
				value=9999;
			}

			break;
		case 2:
			a_route_sel=ang_rs+(180-post_ang_i[1]-short_ang_i[1]);
			if(a_route_sel < 180){
				ang_rs_i[2]=a_route_sel;
			}
			if(a_route_sel > 180){
				ang_rs_i[2]=360-a_route_sel;
			}
			if(a_route_sel == 180){
				ang_rs_i[2]=a_route_sel;
			}
			short_dis_prov=sqrt(pow(short_dis[1],2)+pow(dis_rs,2)-2*short_dis[1]*dis_rs*cos(ang_rs_i[2]*3.1415927/180));
			short_ang_rs_i[2]=asin(dis_rs*sin(ang_rs_i[2]*3.1415927/180)/short_dis_prov)*180/3.1415927;
			dis=sqrt(pow(short_dis[1],2)+pow(short_dis_prov,2)-2*short_dis[1]*short_dis_prov*cos(short_ang_rs_i[2]*3.1415927/180));
			if(dis > dis_rs*0.95){
				if(a_route_sel < 180){
					short_ang_prov=short_ang[1]-short_ang_rs_i[2];
				}
				if(a_route_sel > 180){
					short_ang_prov=short_ang[1]+short_ang_rs_i[2];
				}
				if(a_route_sel == 180){
					short_ang_prov=short_ang[1];
				}
			}else{
				short_ang_rs_i[2]=180-short_ang_rs_i[2];
				if(a_route_sel < 180){
					short_ang_prov=short_ang[1]-short_ang_rs_i[2];
				}
				if(a_route_sel > 180){
					short_ang_prov=short_ang[1]+short_ang_rs_i[2];
				}
				if(a_route_sel == 180){
					short_ang_prov=short_ang[1];
				}
			}

			dis_sin=short_dis_prov*sin(short_ang_prov*3.1415927/180);
			dis_cos=short_dis_prov*cos(short_ang_prov*3.1415927/180);
			if(((0<dis_sin && dis_sin<FIELD_DIAMETER)&&(0<dis_cos && dis_cos<FIELD_DIAMETER/2)) || ((0<dis_sin && dis_sin<FIELD_DIAMETER)&&(-FIELD_DIAMETER/2<dis_cos && dis_cos<0))){
				value=0;
			}else{
				value=9999;
			}

			break;
		case 3:
			b_route_sel=ang_rs+(180-a_route-short_ang_i[2]);
			if(b_route_sel < 180){
				ang_rs_i[3]=b_route_sel;
			}
			if(b_route_sel > 180){
				ang_rs_i[3]=360-b_route_sel;
			}
			if(b_route_sel == 180){
				ang_rs_i[3]=b_route_sel;
			}
			short_dis_prov=sqrt(pow(short_dis[2],2)+pow(dis_rs,2)-2*short_dis[2]*dis_rs*cos(ang_rs_i[3]*3.1415927/180));
			short_ang_rs_i[3]=asin(dis_rs*sin(ang_rs_i[3]*3.1415927/180)/short_dis_prov)*180/3.1415927;
			dis=sqrt(pow(short_dis[2],2)+pow(short_dis_prov,2)-2*short_dis[2]*short_dis_prov*cos(short_ang_rs_i[3]*3.1415927/180));
			if(dis > dis_rs*0.95){
				if(b_route_sel < 180){
					short_ang_prov=short_ang[2]-short_ang_rs_i[3];
				}
				if(b_route_sel > 180){
					short_ang_prov=short_ang[2]+short_ang_rs_i[3];
				}
				if(b_route_sel == 180){
					short_ang_prov=short_ang[2];
				}
			}else{
				short_ang_rs_i[3]=180-short_ang_rs_i[3];
				if(b_route_sel < 180){
					short_ang_prov=short_ang[2]-short_ang_rs_i[3];
				}
				if(b_route_sel > 180){
					short_ang_prov=short_ang[2]+short_ang_rs_i[3];
				}
				if(b_route_sel == 180){
					short_ang_prov=short_ang[2];
				}
			}

			dis_sin=short_dis_prov*sin(short_ang_prov*3.1415927/180);
			dis_cos=short_dis_prov*cos(short_ang_prov*3.1415927/180);
			if(((0<dis_sin && dis_sin<FIELD_DIAMETER)&&(0<dis_cos && dis_cos<FIELD_DIAMETER/2)) || ((0<dis_sin && dis_sin<FIELD_DIAMETER)&&(-FIELD_DIAMETER/2<dis_cos && dis_cos<0))){
				value=0;
			}else{
				value=9999;
			}

			break;
		case 4:
			c_route_sel=ang_rs+(180-b_route-short_ang_i[3]);
			if(c_route_sel < 180){
				ang_rs_i[4]=b_route_sel;
			}
			if(c_route_sel > 180){
				ang_rs_i[4]=360-b_route_sel;
			}
			if(c_route_sel == 180){
				ang_rs_i[4]=b_route_sel;
			}
			short_dis_prov=sqrt(pow(short_dis[3],2)+pow(dis_rs,2)-2*short_dis[3]*ang_rs*cos(ang_rs_i[4]*3.1415927/180));
			short_ang_rs_i[4]=asin(ang_rs*sin(ang_rs_i[4]*3.1415927/180)/short_dis_prov)*180/3.1415927;
			dis=sqrt(pow(short_dis[3],2)+pow(short_dis_prov,2)-2*short_dis[3]*short_dis_prov*cos(short_ang_rs_i[4]*3.1415927/180));
			if(dis > dis_rs*0.95){
				if(c_route_sel < 180){
					short_ang_prov=short_ang[3]-short_ang_rs_i[4];
				}
				if(c_route_sel > 180){
					short_ang_prov=short_ang[3]+short_ang_rs_i[4];
				}
				if(c_route_sel == 180){
					short_ang_prov=short_ang[3];
				}
			}else{
				short_ang_rs_i[4]=180-short_ang_rs_i[4];
				if(c_route_sel < 180){
					short_ang_prov=short_ang[3]-short_ang_rs_i[4];
				}
				if(c_route_sel > 180){
					short_ang_prov=short_ang[3]+short_ang_rs_i[4];
				}
				if(c_route_sel == 180){
					short_ang_prov=short_ang[3];
				}
			}

			dis_sin=short_dis_prov*sin(short_ang_prov*3.1415927/180);
			dis_cos=short_dis_prov*cos(short_ang_prov*3.1415927/180);
			if(((0<dis_sin && dis_sin<FIELD_DIAMETER)&&(0<dis_cos && dis_cos<FIELD_DIAMETER/2)) || ((0<dis_sin && dis_sin<FIELD_DIAMETER)&&(-FIELD_DIAMETER/2<dis_cos && dis_cos<0))){
				value=0;
			}else{
				value=9999;
			}

			break;
		default:break;
	}

	return value;
}
