#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include <math.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"
#include "rotation.h"
#include "led.h"

#define PWM_SLEEP	20000
#define DETECTING_TIME2	5000


/***** select next route *****/
int route4(){
	int j,try_case,dis_mini,ang_mini,ang_maxi,rotate_time,ang_approach_i=0;

	if(search_try_count==1){
		try_case=1;
	}else if(search_try_count>1){
		try_case=2;
	}else{
		try_case=0;
	}

	switch(try_case){
		case 1:
			dis_mini=dis_select[0];
			s_number=0;
			for(j=1;j<search_post;j++){
				if(dis_mini>dis_select[j]){
					dis_mini=dis_select[j];
					s_number=j;
				}
			}
			dis_approach=dis_mini;	
			ang_approach=ang_select[s_number];
			ang_now_1st=ang_approach;
			dis_now=dis_approach;
			ang_now=ang_approach;
			post_ang_dumy[search_try_count-1]=(double)ang_approach;
			post_dis_dumy[search_try_count-1]=(double)dis_approach;

			if(ang_approach<90){
				ang_approach_i=(-1)*(90-ang_approach);
			}else if(ang_approach>90){
				ang_approach_i=ang_approach-90;
			}else if(ang_approach==90){
				ang_approach_i=0;
			}else{
				
			}

			rotate_time=abs(ang_approach_i*20);
			lqr_rotate((int)(ang_approach_i*ANGLE_DIFF),rotate_time);
			usleep(300000);
			pwm_both_data(0,0);
			usleep(PWM_SLEEP);
			
			break;
			
		case 2:
			if(ang_now_1st>=90){
				ang_maxi=ang_select[0];
				s_number=0;
				for(j=1;j<search_post;j++){
					if(ang_maxi<ang_select[j]){
						ang_maxi=ang_select[j];
						s_number=j;
					}
				}
				ang_approach=ang_maxi;
				dis_approach=dis_select[s_number];
				dis_now=dis_approach;
				ang_now=ang_approach;
				post_ang_dumy[search_try_count-1]=(double)ang_approach;
				post_dis_dumy[search_try_count-1]=(double)dis_approach;

				if(ang_approach>180){
					ang_approach_i=ang_approach-360;
				}else{
					ang_approach_i=ang_approach;
				}

				rotate_time=abs(ang_approach_i*55);
				pwm_enco_start(10);
				usleep(PWM_SLEEP);
				pwm_lqr_circle(circle_radious,(int)(ang_approach_i*ANGLE_DIFF2),rotate_time);
				
				count.br=0;
				while(1){
					if(count.br==1) {
						pwm_both_data(0,0);
						usleep(PWM_SLEEP);
						pwm_enco_stop();
						usleep(PWM_SLEEP);
						lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
						break;
					}
				}
			}
			if(ang_now_1st<90){
				ang_mini=ang_select[0];
				s_number=0;
				for(j=1;j<search_post;j++){
					if(ang_mini>ang_select[j]){
						ang_mini=ang_select[j];
						s_number=j;
					}
				}
				ang_approach=ang_mini;
				dis_approach=dis_select[s_number];
				dis_now=dis_approach;
				ang_now=ang_approach;
				post_ang_dumy[search_try_count-1]=(double)ang_approach;
				post_dis_dumy[search_try_count-1]=(double)dis_approach;
				
				if(ang_approach>180){
					ang_approach_i=ang_approach-360;
				}else{
					ang_approach_i=ang_approach;
				}

				rotate_time=abs(ang_approach_i*55);				
				pwm_enco_start(10);
				usleep(PWM_SLEEP);
				pwm_lqr_circle(circle_radious,(int)(ang_approach_i*ANGLE_DIFF2),rotate_time);
				count.br=0;
				while(1){
					if(count.br==1) {
						pwm_both_data(0,0);
						usleep(PWM_SLEEP);
						pwm_enco_stop();
						usleep(PWM_SLEEP);
						lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
						break;
					}
				}
			}

			break;

		default:break;
	}
	return 0;
}


/***** go to center of field , reselect post *****/
int route5(){
	int i,try_case,rotate_time,ang_approach_i;
	double x,y,y2,a,b,c;
	int retry_cnt=1;
	int dis_prov,ang_prov;
	int target_post=1;
	int post_sure=0;
	double angle=0;
	int direction=0;

	if(warning_point==1){
		try_case=1;
	}else if(warning_point==2){
		try_case=2;
	}else{
		try_case=0;
	}

	switch(try_case){
		case 1:
			x=short_ang[search_try_sure-1]*cos(short_ang[search_try_sure-1]*3.1415927/180);
			y=short_ang[search_try_sure-1]*sin(short_ang[search_try_sure-1]*3.1415927/180);
			if(search_try_count==1 && search_post==0){

				dis_approach=(int)FIELD_DIAMETER/2;

				ang_approach=0;
				dis_now=dis_approach;
				ang_now=ang_approach;
				ang_now_1st=90;
				angle=0;
				direction=1;
				lqr_straight(dis_approach,8000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);
				rot2(angle,direction);
				pthread_cancel(uss_task2);
				usleep(300000);
				flag_calculated=1;
				warning_point=3;
				break;
			}	/*start point*/

			if((x>=0 && y>=(FIELD_DIAMETER/2)) && short_ang[search_try_sure-1]>short_ang[search_try_sure-2]){

				y2=y-(FIELD_DIAMETER/2);

				dis_approach=(int)(sqrt(pow(x,2)+pow(y2,2))+0.5);
				a=asin(x/dis_approach)*180/3.1415927;
				b=asin(x/short_dis[search_try_sure-1])*180/3.1415927;
				c=180-post_ang_i[search_try_sure-1]-short_ang_i[search_try_sure-1];
				ang_cent_a=a;
				ang_approach=(int)(a-b+c+0.5);
				dis_now=dis_approach;
				ang_now=ang_approach;
				
				rotate_time=abs(ang_approach*55);
				pwm_lqr_circle(circle_radious,-(int)(ang_approach*ANGLE_DIFF2),rotate_time);
				usleep(PWM_SLEEP);
				pwm_both_data(0,0);
				usleep(PWM_SLEEP);
				pwm_enco_stop();
				usleep(PWM_SLEEP);
				lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
				usleep(PWM_SLEEP);
				
				lqr_straight((int)(dis_approach-360-post_diameter/2),8000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				
				lqr_rotate(-(int)(90-a),3000);
				usleep(400000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				angle=0;
				direction=1;
				usleep(400000);
				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);
				rot2(angle,direction);
				pthread_cancel(uss_task2);
				usleep(300000);
				flag_calculated=2;
				warning_point=3;
				break;
			}	/*1st quadrant -a*/
			
			if((x>=0 && y>=(FIELD_DIAMETER/2)) && short_ang[search_try_sure-1]<short_ang[search_try_sure-2]){

				y2=y-(FIELD_DIAMETER/2);

				dis_approach=(int)(sqrt(pow(x,2)+pow(y2,2))+0.5);
			
				a=asin(x/dis_approach)*180/3.1415927;
				b=asin(x/short_dis[search_try_sure-1])*180/3.1415927;
				c=180-short_ang_i[search_try_sure-1]-post_ang_i[search_try_sure-1];
				ang_cent_a=a;
				ang_approach=(int)(b+c-a+0.5);
				dis_now=dis_approach;
				ang_now=ang_approach;
				
				rotate_time=abs(ang_approach*55);
				lqr_circle(circle_radious,(int)(ang_approach*ANGLE_DIFF2),rotate_time);
				usleep(PWM_SLEEP);
				pwm_both_data(0,0);
				usleep(PWM_SLEEP);
				pwm_enco_stop();
				usleep(PWM_SLEEP);
				lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
				usleep(PWM_SLEEP);
				
				lqr_straight((int)(dis_approach-360-post_diameter/2),8000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				
				lqr_rotate((int)a,3000);
				usleep(400000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				angle=0;
				direction=1;
				usleep(400000);
				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);
				rot2(angle,direction);
				pthread_cancel(uss_task2);
				usleep(300000);
				flag_calculated=3;
				warning_point=3;
				break;
			}	/*1st quadrant -b*/

			if((x<0 && y>=(FIELD_DIAMETER/2)) && short_ang[search_try_sure-1]<short_ang[search_try_sure-2]){

				y2=y-(FIELD_DIAMETER/2);

				dis_approach=(int)(sqrt(pow(x,2)+pow(y2,2))+0.5);

				a=asin(-x/dis_approach)*180/3.1415927;
				b=asin(-x/short_dis[search_try_sure-1])*180/3.1415927;
				c=180-short_ang_i[search_try_sure-1]-post_ang_i[search_try_sure-1];
				ang_cent_a=a;
				ang_approach=(int)(b+c-a+0.5);
				dis_now=dis_approach;
				ang_now=ang_approach;
				
				rotate_time=abs(ang_approach*55);
				lqr_circle(circle_radious,(int)(ang_approach*ANGLE_DIFF2),rotate_time);
				usleep(PWM_SLEEP);
				pwm_both_data(0,0);
				usleep(PWM_SLEEP);
				pwm_enco_stop();
				usleep(PWM_SLEEP);
				lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
				usleep(PWM_SLEEP);
				
				lqr_straight((int)(dis_approach-360-post_diameter/2),8000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				
				lqr_rotate((int)(90-a),3000);
				usleep(400000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				angle=0;
				direction=1;
				usleep(400000);
				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);
				rot2(angle,direction);
				pthread_cancel(uss_task2);
				usleep(300000);
				flag_calculated=4;
				warning_point=3;
				break;
			}	/*2nd quadrant -a*/
			
			if((x<0 && y>=(FIELD_DIAMETER/2)) && short_ang[search_try_sure-1]>short_ang[search_try_sure-2]){

				y2=y-(FIELD_DIAMETER/2);

				dis_approach=(int)(sqrt(pow(x,2)+pow(y2,2))+0.5);

				a=asin(-x/dis_approach)*180/3.1415927;
				b=asin(-x/short_dis[search_try_sure-1])*180/3.1415927;
				c=180-short_ang_i[search_try_sure-1]-post_ang_i[search_try_sure-1];
				ang_cent_a=a;
				ang_approach=(int)(b+c-a+0.5);
				dis_now=dis_approach;
				ang_now=ang_approach;
				
				rotate_time=abs(ang_approach*55);
				lqr_circle(circle_radious,-(int)(ang_approach*ANGLE_DIFF2),rotate_time);
				usleep(PWM_SLEEP);
				pwm_both_data(0,0);
				usleep(PWM_SLEEP);
				pwm_enco_stop();
				usleep(PWM_SLEEP);
				lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
				usleep(PWM_SLEEP);
				
				lqr_straight((int)(dis_approach-360-post_diameter/2),8000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				
				lqr_rotate(-(int)a,3000);
				usleep(400000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				angle=0;
				direction=1;
				usleep(400000);
				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);
				rot2(angle,direction);
				pthread_cancel(uss_task2);
				usleep(300000);
				flag_calculated=5;
				warning_point=3;
				break;
			}	/*2nd quadrant -b*/
			
			if((x<0 && y<(FIELD_DIAMETER/2)) && ang_before==0){

				y2=(FIELD_DIAMETER/2)-y;

				dis_approach=(int)(sqrt(pow(x,2)+pow(y2,2))+0.5);

				a=asin(y2/dis_approach)*180/3.1415927;
				b=asin(y/short_dis[search_try_sure-1])*180/3.1415927;
				ang_cent_a=a;
				ang_approach=(int)(b+a+0.5);
				dis_now=dis_approach;
				ang_now=ang_approach;

				rotate_time=abs(ang_approach*55);
				lqr_circle(circle_radious,(int)(ang_approach*ANGLE_DIFF2),rotate_time);
				usleep(PWM_SLEEP);
				pwm_both_data(0,0);
				usleep(PWM_SLEEP);
				pwm_enco_stop();
				usleep(PWM_SLEEP);
				lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
				usleep(PWM_SLEEP);
				
				lqr_straight((int)(dis_approach-360-post_diameter/2),8000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				
				lqr_rotate((int)(90-a),3000);
				usleep(400000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				angle=0;
				direction=1;
				usleep(400000);
				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);
				rot2(angle,direction);
				pthread_cancel(uss_task2);
				usleep(300000);
				flag_calculated=6;
				warning_point=3;
				break;
			}	/*3rd quadrant -a*/
			
			if((x<0 && y<(FIELD_DIAMETER/2)) && short_ang[search_try_sure-1]>short_ang[search_try_sure-2]){

				y2=(FIELD_DIAMETER/2)-y;

				dis_approach=(int)(sqrt(pow(x,2)+pow(y2,2))+0.5);

				a=asin(y2/dis_approach)*180/3.1415927;
				b=asin(y/short_dis[search_try_sure-1])*180/3.1415927;
				c=180-short_ang_i[search_try_sure-1]-post_ang_i[search_try_sure-1];
				ang_cent_a=a;
				ang_approach=(int)(b+a-c+0.5);
				dis_now=dis_approach;
				ang_now=ang_approach;

				rotate_time=abs(ang_approach*55);
				lqr_circle(circle_radious,(int)(ang_approach*ANGLE_DIFF2),rotate_time);
				usleep(PWM_SLEEP);
				pwm_both_data(0,0);
				usleep(PWM_SLEEP);
				pwm_enco_stop();
				usleep(PWM_SLEEP);
				lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
				usleep(PWM_SLEEP);
				
				lqr_straight((int)(dis_approach-360-post_diameter/2),8000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				
				lqr_rotate((int)(90-a),3000);
				usleep(400000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				angle=0;
				direction=1;
				usleep(400000);
				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);
				rot2(angle,direction);
				pthread_cancel(uss_task2);
				usleep(300000);
				flag_calculated=7;
				warning_point=3;
				break;
			}	/*3rd quadrant -d*/

			if((x<0 && y<(FIELD_DIAMETER/2)) && short_ang[search_try_sure-1]<short_ang[search_try_sure-2]){

				y2=(FIELD_DIAMETER/2)-y;

				dis_approach=(int)(sqrt(pow(x,2)+pow(y2,2))+0.5);

				a=asin(y2/dis_approach)*180/3.1415927;
				b=asin(y/short_dis[search_try_sure-1])*180/3.1415927;
				c=180-short_ang_i[search_try_sure-1]-post_ang_i[search_try_sure-1];
				ang_cent_a=a;
				ang_approach=(int)(a+b+c+0.5);
				dis_now=dis_approach;
				ang_now=ang_approach;

				if(ang_approach>180){
					ang_approach_i=ang_approach-360;
				}else{
					ang_approach_i=ang_approach;
				}

				rotate_time=abs(ang_approach*55);
				lqr_circle(circle_radious,(int)(ang_approach_i*ANGLE_DIFF2),rotate_time);
				usleep(PWM_SLEEP);
				pwm_both_data(0,0);
				usleep(PWM_SLEEP);
				pwm_enco_stop();
				usleep(PWM_SLEEP);
				lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
				usleep(PWM_SLEEP);
				
				lqr_straight((int)(dis_approach-360-post_diameter/2),8000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				
				lqr_rotate((int)(90-a),3000);
				usleep(400000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				angle=0;
				direction=1;
				usleep(400000);
				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);
				rot2(angle,direction);
				pthread_cancel(uss_task2);
				usleep(300000);
				flag_calculated=8;
				warning_point=3;
				break;
			}	/*3rd quadrant -c*/

			if((x>0 && y<(FIELD_DIAMETER/2)) && ang_before==0){

				y2=(FIELD_DIAMETER/2)-y;

				dis_approach=(int)(sqrt(pow(x,2)+pow(y2,2))+0.5);

				a=asin(y2/dis_approach)*180/3.1415927;
				b=asin(y/short_dis[search_try_sure-1])*180/3.1415927;
				ang_cent_a=a;
				ang_approach=(int)(b+a+0.5);
				dis_now=dis_approach;
				ang_now=ang_approach;

				rotate_time=abs(ang_approach*55);
				pwm_lqr_circle(circle_radious,-(int)(ang_approach*ANGLE_DIFF2),rotate_time);
				usleep(PWM_SLEEP);
				pwm_both_data(0,0);
				usleep(PWM_SLEEP);
				pwm_enco_stop();
				usleep(PWM_SLEEP);
				lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
				usleep(PWM_SLEEP);
				
				lqr_straight((int)(dis_approach-360-post_diameter/2),8000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				
				lqr_rotate((int)(a-90),3000);
				usleep(400000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				angle=0;
				direction=1;
				usleep(400000);
				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);
				rot2(angle,direction);
				pthread_cancel(uss_task2);
				usleep(300000);
				flag_calculated=9;
				warning_point=3;
				break;
			}	/*4th quadrant -a*/
			
			if((x>0 && y<(FIELD_DIAMETER/2)) && short_ang[search_try_sure-1]<short_ang[search_try_sure-2]){

				y2=(FIELD_DIAMETER/2)-y;

				dis_approach=(int)(sqrt(pow(x,2)+pow(y2,2))+0.5);

				a=asin(y2/dis_approach)*180/3.1415927;
				b=asin(y/short_dis[search_try_sure-1])*180/3.1415927;
				c=180-short_ang_i[search_try_sure-1]-post_ang_i[search_try_sure-1];
				ang_cent_a=a;
				ang_approach=(int)(b+a-c+0.5);
				dis_now=dis_approach;
				ang_now=ang_approach;

				rotate_time=abs(ang_approach*55);
				lqr_circle(circle_radious,-(int)(ang_approach*ANGLE_DIFF2),rotate_time);
				usleep(PWM_SLEEP);
				pwm_both_data(0,0);
				usleep(PWM_SLEEP);
				pwm_enco_stop();
				usleep(PWM_SLEEP);
				lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
				usleep(PWM_SLEEP);
				
				lqr_straight((int)(dis_approach-360-post_diameter/2),8000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				
				lqr_rotate((int)(90-a),3000);
				usleep(400000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				angle=0;
				direction=1;
				usleep(400000);
				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);
				rot2(angle,direction);
				pthread_cancel(uss_task2);
				usleep(300000);
				flag_calculated=10;
				warning_point=3;
				break;
			}	/*4th quadrant -d*/

			if((x>0 && y<(FIELD_DIAMETER/2)) && short_ang[search_try_sure-1]>short_ang[search_try_sure-2]){

				y2=(FIELD_DIAMETER/2)-y;

				dis_approach=(int)(sqrt(pow(x,2)+pow(y2,2))+0.5);

				a=asin(y2/dis_approach)*180/3.1415927;
				b=asin(y/short_dis[search_try_sure-1])*180/3.1415927;
				c=180-short_ang_i[search_try_sure-1]-post_ang_i[search_try_sure-1];
				ang_cent_a=a;
				ang_approach=(int)(a+b+c+0.5);
				dis_now=dis_approach;
				ang_now=ang_approach;

				if(ang_approach>180){
					ang_approach_i=ang_approach-360;
				}else{
					ang_approach_i=ang_approach;
				}

				rotate_time=abs(ang_approach*55);
				usleep(PWM_SLEEP);
				lqr_circle(circle_radious,(int)(ang_approach_i*ANGLE_DIFF2),rotate_time);
				usleep(PWM_SLEEP);
				pwm_both_data(0,0);
				usleep(PWM_SLEEP);
				pwm_enco_stop();
				usleep(PWM_SLEEP);
				lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
				usleep(PWM_SLEEP);
				
				lqr_straight((int)(dis_approach-360-post_diameter/2),8000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				
				lqr_rotate((int)(90-a),3000);
				usleep(400000);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				angle=0;
				direction=1;
				usleep(400000);
				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);
				rot2(angle,direction);
				pthread_cancel(uss_task2);
				usleep(300000);
				flag_calculated=11;
				warning_point=3;
				break;
			}	/*4th quadrant -c*/

			break;
			
		case 2:
			i=1;

			while(search_post-i>0){
				if(ang_now_1st>=90){
					ang_prov=ang_select[s_number-i];
					dis_prov=dis_select[s_number-i];

					post_ang_dumy[search_try_count-1]=(double)ang_prov;
					post_dis_dumy[search_try_count-1]=(double)dis_prov;
					ang_approach_i=abs(ang_approach-ang_prov);

					rotate_time=abs(ang_approach_i*55);
					pwm_enco_start(10);
					usleep(PWM_SLEEP);
					pwm_lqr_circle(circle_radious,-(int)(ang_approach_i*ANGLE_DIFF2),rotate_time);
				
					count.br=0;
					while(1){
						if(count.br==1) {
							pwm_both_data(0,0);
							usleep(PWM_SLEEP);
							pwm_enco_stop();
							usleep(PWM_SLEEP);
							lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
							break;
						}
					}
				}
	
				if(ang_now_1st<90){
					ang_prov=ang_select[s_number+i];
					dis_prov=dis_select[s_number+i];

					post_ang_dumy[search_try_count-1]=(double)ang_prov;
					post_dis_dumy[search_try_count-1]=(double)dis_prov;
					ang_approach_i=abs(ang_prov-ang_approach);

					rotate_time=abs(ang_approach_i*55);
					pwm_enco_start(10);
					usleep(PWM_SLEEP);
					pwm_lqr_circle(circle_radious,(int)(ang_approach_i*ANGLE_DIFF2),rotate_time);
				
					count.br=0;
					while(1){
						if(count.br==1) {
							pwm_both_data(0,0);
							usleep(PWM_SLEEP);
							pwm_enco_stop();
							usleep(PWM_SLEEP);
							lqr_rotate(-(int)(90*ANGLE_DIFF),3000);
							break;
						}
					}
				}

				printf("Approach Post! \n");

				pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);
				usleep(300000);	
				post_sure=post_approach0702(target_post);
				usleep(300000);
				pwm_both_data(0,0);
				usleep(400000);
				pthread_cancel(uss_task2);
				usleep(300000);

				if(post_sure==0){
					dis_approach=dis_prov;
					ang_approach=ang_prov;
					post_dis[sure]=post_dis_dumy[search_try_count-1];
					post_ang[sure]=post_ang_dumy[search_try_count-1];
					search_try_sure++;
					warning_point=0;
					break;
				}else{
					lqr_rotate((int)(90*ANGLE_DIFF),3000);
					retry_cnt++;
					i++;
				}
			}
			if(search_post-retry_cnt<=0 && search_try_count>1){
				if(ang_now_1st>=90){
					rotate_time=abs(ang_prov*55);
					lqr_circle(circle_radious,-(int)(ang_prov*ANGLE_DIFF2),rotate_time);
				}
	
				if(ang_now_1st<90){
					rotate_time=abs(ang_prov*55);
					lqr_circle(circle_radious,(int)(ang_prov*ANGLE_DIFF2),rotate_time);
				}	
				warning_point=1;
			}
			if(search_try_count==1){
				ang_before=0;
				dis_before=0;
				warning_point=1;
			}
			break;

		default:
			break;
	}
	return 0;
}