#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include "pwm_enc.h"

// RT-Task Start function
void pwm_enco_start(int period) /* [msec] */
{
	int fd3; 
	struct my_msg_struct msg;

	// FIFO Open
	if((fd3 = open("/dev/rtf5", O_WRONLY)) < 0){
		fprintf(stderr, "Error opening /dev/rtf5\n");
		exit(1);
	}
	// Input command data
	msg.command = START_TASK;
	msg.task = 2;
	msg.period = period;
	printf("now pwm_enco_start\n");
	// Write command to FIFO
	if(write(fd3, &msg, sizeof(msg)) < 0){
		printf("if\n");
		fprintf(stderr, "Can't send a command to RT-task\n");
		exit(1);
	}
	printf("before }\n");
	close(fd3); 
}

// RT-Task Stop function
void pwm_enco_stop(void)
{
	int fd3; 
	struct my_msg_struct msg;

	if((fd3 = open("/dev/rtf5", O_WRONLY)) < 0){
		fprintf(stderr, "Error opening /dev/rtf5\n");
		exit(1);
	} 
	msg.command = STOP_TASK;
	msg.task = 2;
	if(write(fd3, &msg, sizeof(msg)) < 0){
		fprintf(stderr, "Can't send a command to RT-task\n");
		exit(1);
	}
	close(fd3); 
}

// RT-Task Re-Start function
void pwm_enco_restart(void)
{
	int fd3; 
	struct my_msg_struct msg;

	 if((fd3 = open("/dev/rtf5", O_WRONLY)) < 0){
		fprintf(stderr, "Error opening /dev/rtf5\n");
		exit(1);
	} 
	msg.command = RESTART_TASK;
	msg.task = 2;
	if(write(fd3, &msg, sizeof(msg)) < 0){
		fprintf(stderr, "Can't send a command to RT-task\n");
		exit(1);
	}
	close(fd3); 
}
