/*************************************************************
*     encoder.c  Encoder reading  Ver.1.0                    *
*                                          Date:14 May 2004  *
*                                Programed by Hiroki.Segawa  *
*************************************************************/

/*************************************************************
*       This Source file contains these function.            *
*                                                            *
* void encoder_data(float *,float *,float *,float *,int *);  *
*                                                            *
*  This function is read encoder count from fifo and         *
* calculation of distance,velocity.                          *
*************************************************************/

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include "pwm_enc.h"

void encoder_data5(float *omega_l, float *omega_r, float *vel, float *Omega, int *br){
	fd_set rfds;
	struct timeval tv;
	struct count_data count;
	int retval1, retval2;
	int fd1 = 0; 
	static int ct;

	// FIFO Open
	if ((fd1 = open("/dev/rtf3", O_RDONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf3\n");
                return;
	}
	// Read from FIFO
	FD_ZERO(&rfds);
	FD_SET(fd1, &rfds);
	tv.tv_sec = 0;
	//tv.tv_usec = 1000000; // Reading Period 1s
	//tv.tv_usec = 100000; // Reading Period 100ms
	tv.tv_usec = 20000; //Reading Period 20ms
	//tv.tv_usec = 10000; // Reading Period 10ms
	retval1 = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
	if(retval1 > 0){
	//retval1 = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
		ct++;
		while(1){
			read(fd1, &count, sizeof(count)); // Read from FIFO
			retval2 = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
			if(retval2 == 0) break;
		}
	}
	// count.left_sum count.right_sum is encoder count pulse
	// calculation of velocity
	*omega_l = -count.left_count * 2 * pi / 0.01 / (cpr * gear);
	*omega_r = count.right_count * 2 * pi / 0.01 / (cpr * gear);
	//printf("count.left_count=%d\n",count.left_count);
	printf("ct=%d\n",ct);
	*vel= (*omega_l + *omega_r)/2 * diameter/2;
	*Omega= (*omega_l - *omega_r)/2 * diameter/2/dist_ct;
	*br = count.br; // end flag.if br=1,control ended
	close(fd1);
}
